
#include "src/systemc.h"
using namespace sc_core ; 
struct dcache : sc_module { 
  	sc_in<signed> 		datain; 	// input data
  	sc_in<unsigned>  	statein; 	// input state bit MESI(=3210)
  	sc_in<bool>  		cs;    		// chip select
  	sc_in<bool>  		we;    		// write enable 
  	sc_in<unsigned >  	addr;  		// address
  	sc_in<unsigned>  	dest;    	// write back to which register
  	sc_out<unsigned>  	destout;    	// write back to which register
  	sc_out<signed>  	dataout;  	// dataram data out
  	sc_out<bool>  		out_valid;    	// output valid
  	sc_out<unsigned>  	stateout;  	// state output
    sc_in_clk 			CLK;
 

#define dcachesize 4000

	// Parameter

  int wait_cycles; 					// cycles # it takes to access dmemory

  void init (int given_delay_cycles) 
  {
    wait_cycles = given_delay_cycles;
  }



  //Constructor 
  SC_CTOR(dcache) {
	  SC_CTHREAD(entry_dcache, CLK.pos());
  }

	// initialize instruction dmemory from external file
	


  // Process functionality in member function below
  void entry_dcache();
  
};
