

#ifndef SYSTEMC_INCLUDED
#define SYSTEMC_INCLUDED

// include this file first
#include "sysc/kernel/sc_cmnhdr.h"

#include "sysc/kernel/sc_externs.h"
#include "sysc/kernel/sc_module.h"
#include "sysc/kernel/sc_simcontext.h"
#include "sysc/kernel/sc_process_handle.h"


#include "sysc/communication/sc_buffer.h"
#include "sysc/communication/sc_clock.h"
#include "sysc/communication/sc_clock_ports.h"
#include "sysc/communication/sc_event_queue.h"
#include "sysc/communication/sc_export.h"
#include "sysc/communication/sc_fifo.h"
#include "sysc/communication/sc_fifo_ports.h"
#include "sysc/communication/sc_mutex.h"
#include "sysc/communication/sc_semaphore.h"
#include "sysc/communication/sc_signal.h"
#include "sysc/communication/sc_signal_ports.h"

#include "sysc/communication/sc_signal_resolved.h"
#include "sysc/communication/sc_signal_resolved_ports.h"
#include "sysc/communication/sc_signal_rv.h"
#include "sysc/communication/sc_signal_rv_ports.h"

#include "sysc/datatypes/bit/sc_bit.h"
#include "sysc/datatypes/bit/sc_logic.h"
#include "sysc/datatypes/bit/sc_bv.h"
#include "sysc/datatypes/bit/sc_lv.h"

#include "sysc/datatypes/int/sc_bigint.h"
#include "sysc/datatypes/int/sc_biguint.h"
#include "sysc/datatypes/int/sc_int.h"
#include "sysc/datatypes/int/sc_uint.h"

#include "sysc/datatypes/misc/sc_concatref.h" 

#ifdef SC_INCLUDE_FX
#   include "sysc/datatypes/fx/fx.h"
#endif // SC_INCLUDE_FX

#ifdef SC_INCLUDE_DYNAMIC_PROCESSES
#    include "sysc/kernel/sc_dynamic_processes.h"
#endif // SC_INCLUDE_DYNAMIC_PROCESSES

#include "sysc/tracing/sc_vcd_trace.h"
#include "sysc/tracing/sc_wif_trace.h"

#include "sysc/utils/sc_iostream.h"
#include "sysc/utils/sc_utils_ids.h"

#endif // !defined(SYSTEMC_INCLUDED)
